unit uFormBaelleFangen;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  mTSpielfeld, mTKugel, ExtCtrls, StdCtrls, mKnopf, mEtikett,mSuM;

type
  TFormBaelleFangen = class(TForm)
    hatZeitgeberBewegung: TTimer;
    hatStartKnopf: TKnopf;
    Etikett1: TEtikett;
    hatEtAnzahlBaelle: TEtikett;
    hatZeitgeberAnzahl: TTimer;
    hatEtErgebnis: TEtikett;
    Knopf1: TKnopf;
    procedure FormActivate(Sender: TObject);
    procedure hatZeitgeberBewegungTimer(Sender: TObject);
    procedure hatStartKnopfGeklickt(Sender: TObject);
    procedure hatZeitgeberAnzahlTimer(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Knopf1Geklickt(Sender: TObject);
  private
    zAnzahlBaelle : ganzeZahl;
    hatSpielfeld : TSpielfeld;
    hatBaelle    : array [1..10] of TKugel;
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FormBaelleFangen: TFormBaelleFangen;

implementation

{$R *.DFM}

procedure TFormBaelleFangen.FormActivate(Sender: TObject);
var i : ganzeZahl;
begin
   hatSpielfeld := TSpielfeld.init(10,10,self.width-20,self.height-100);
   randomize;
   for i := 1 to 10 do
      begin
         hatBaelle[i] := TKugel.init(20+random(self.width-40),
                                     20+random(self.height-130),
                                     random(360));
         hatBaelle[i].merkeSpielfeld(hatSpielfeld);
         if i <= 5 then
             hatBaelle[i].verstecke
      end;
   zAnzahlBaelle := 5;
   hatEtAnzahlBaelle.setzeInhalt(zAnzahlBaelle)   
end;

procedure TFormBaelleFangen.hatZeitgeberBewegungTimer(Sender: TObject);
var i : ganzeZahl ;
begin
  for i := 1 to 10 do
     hatBaelle[i].bewege
end;

procedure TFormBaelleFangen.hatStartKnopfGeklickt(Sender: TObject);
begin
   hatZeitgeberBewegung.Enabled := true;
   hatZeitgeberAnzahl.Enabled := true
end;

procedure TFormBaelleFangen.hatZeitgeberAnzahlTimer(Sender: TObject);
var i,nummer : ganzeZahl ;
begin
   if zAnzahlBaelle < 10 then
      begin
         zAnzahlBaelle := zAnzahlBaelle +1;
         hatEtAnzahlBaelle.setzeInhalt(zAnzahlBaelle);
         for i := 1 to zAnzahlBaelle do
            begin
               if not hatBaelle[i].sichtbar then
                  nummer := i
            end;
         hatBaelle[nummer].zeige;
      end
   else
      begin
         hatZeitgeberBewegung.enabled := false;
         hatZeitgeberAnzahl.enabled := false;
         hatEtErgebnis.setzeInhalt('SIE HABEN VERLOREN')
      end
end;

procedure TFormBaelleFangen.FormMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var i :ganzeZahl ;
begin
   for i := 1 to 10 do
         if hatBaelle[i].Treffer(x,y) then
             begin
                hatBaelle[i].verstecke;
                zAnzahlBaelle := zAnzahlBaelle-1;
                hatEtAnzahlBaelle.setzeInhalt(zAnzahlBaelle)
             end ;
   if zAnzahlBaelle = 0 then
      begin
         hatZeitgeberBewegung.enabled := false;
         hatZeitgeberAnzahl.enabled := false;
         hatEtErgebnis.setzeInhalt('');
         hatEtErgebnis.setzeInhalt('SIE HABEN GEWONNEN')
      end
end;

procedure TFormBaelleFangen.Knopf1Geklickt(Sender: TObject);
var i : ganzeZahl;
begin
   hatZeitgeberBewegung.Enabled := false;
   hatZeitgeberAnzahl.Enabled := false;
   for i := 1 to 10 do
      if assigned(hatBaelle[i]) then
         begin
            hatBaelle[i].hatStift.setzefarbe(gruen);
            hatBaelle[i].zeichne
         end
end;

end.
