UNIT mTKnopf;

interface

uses          dialogs,mSuM;
// Uses-Klausel ggf. anpassen

type
   TKnopf = CLASS

     // Attribute
     protected
         hatStift : BuntStift;
         kenntMaus : Maus;
         kannGedruecktWerden : Wahrheitswert;
         zGroesse : Zahl;
         zXPos : Zahl;
         zYPos : Zahl;
         zAufschrift : Zeichenkette;
     public
        clickAktion : procedure of Object;

     // Methoden
     protected
        procedure zeichne; virtual; abstract;
     public
        constructor init(pX,pY,pGroesse:Zahl;pAufschrift:Zeichenkette;pMaus:Maus);
        procedure bearbeiteMausClick; virtual;
        procedure clickdummy;
        function angeklickt : Wahrheitswert; virtual; abstract;
        function innerhalb : Wahrheitswert; virtual; abstract;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKnopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TKnopf.init(pX,pY,pGroesse:Zahl;pAufschrift:Zeichenkette;pMaus:Maus);
begin
  kannGedruecktWerden := True;
  zXpos := pX;
  zYPos := py;
  zGroesse := pGroesse;
  zAufschrift := pAufschrift;
  kenntMaus := pMaus;
  //clickAktion := clickdummy;
  hatStift := BuntStift.init;
  hatStift.wechsle;
  zeichne
end;

//-------- bearbeiteMausClick (public) ---------------------------------
procedure TKnopf.bearbeiteMausClick;
begin
   if innerhalb
      then clickAktion
end;

//-------- clickdummy (public) -----------------------------------------
procedure TKnopf.clickdummy;
begin
  //showmessage('clickdummy')
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKnopf.gibFrei;
begin
  zeichne
end;

end.
