unit uTRechner;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    EdDisplay: TEdit;
    Bt1: TButton;
    Bt2: TButton;
    Bt3: TButton;
    Bt4: TButton;
    Bt5: TButton;
    Bt6: TButton;
    Bt7: TButton;
    Bt8: TButton;
    Bt9: TButton;
    Bt0: TButton;
    BtVz: TButton;
    BtK: TButton;
    BtGl: TButton;
    BtQ: TButton;
    BtP: TButton;
    BtD: TButton;
    BtS: TButton;
    BtClear: TButton;
    BtOff: TButton;
    BtRoot: TButton;
    BtFak: TButton;
    procedure Bt1Click(Sender: TObject);
    procedure Bt2Click(Sender: TObject);
    procedure Bt8Click(Sender: TObject);
    procedure Bt3Click(Sender: TObject);
    procedure Bt4Click(Sender: TObject);
    procedure Bt5Click(Sender: TObject);
    procedure Bt6Click(Sender: TObject);
    procedure Bt7Click(Sender: TObject);
    procedure Bt9Click(Sender: TObject);
    procedure Bt0Click(Sender: TObject);
    procedure BtSClick(Sender: TObject);
    procedure BtGlClick(Sender: TObject);
    procedure BtDClick(Sender: TObject);
    procedure BtPClick(Sender: TObject);
    procedure BtQClick(Sender: TObject);
    procedure BtVzClick(Sender: TObject);
    procedure BtClearClick(Sender: TObject);
    procedure BtOffClick(Sender: TObject);
    procedure BtKClick(Sender: TObject);
    procedure BtRootClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure BtFakClick(Sender: TObject);
  private
    { Private-Deklarationen }
    op1,op2, erg : Real;
    rz      : Char;
    neu     : Boolean;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Bt1Click(Sender: TObject);
begin
  IF neu Then
     BEGIN
       BtClearClick(Sender);
       neu := False
     END;
  EdDisplay.Text :=EdDisplay.Text+'1'
end;

procedure TForm1.Bt2Click(Sender: TObject);
begin
  IF neu Then
     BEGIN
       BtClearClick(Sender);
       neu := False
     END;
  EdDisplay.Text :=EdDisplay.Text+'2'
end;

procedure TForm1.Bt3Click(Sender: TObject);
begin
   IF neu Then
     BEGIN
       BtClearClick(Sender);
       neu := False
     END;
   EdDisplay.Text :=EdDisplay.Text+'3'
end;

procedure TForm1.Bt4Click(Sender: TObject);
begin
  IF neu Then
     BEGIN
       BtClearClick(Sender);
       neu := False
     END;
  EdDisplay.Text :=EdDisplay.Text+'4'
end;

procedure TForm1.Bt5Click(Sender: TObject);
begin
  IF neu Then
     BEGIN
       BtClearClick(Sender);
       neu := False
     END;
  EdDisplay.Text :=EdDisplay.Text+'5'
end;

procedure TForm1.Bt6Click(Sender: TObject);
begin
  IF neu Then
     BEGIN
       BtClearClick(Sender);
       neu := False
     END;
  EdDisplay.Text :=EdDisplay.Text+'6'
end;

procedure TForm1.Bt7Click(Sender: TObject);
begin
  IF neu Then
     BEGIN
       BtClearClick(Sender);
       neu := False
     END;
  EdDisplay.Text :=EdDisplay.Text+'7'
end;

procedure TForm1.Bt8Click(Sender: TObject);
begin
  IF neu Then
     BEGIN
       BtClearClick(Sender);
       neu := False
     END;
  EdDisplay.Text :=EdDisplay.Text+'8'
end;

procedure TForm1.Bt9Click(Sender: TObject);
begin
  IF neu Then
     BEGIN
       BtClearClick(Sender);
       neu := False
     END;
  EdDisplay.Text :=EdDisplay.Text+'9'
end;

procedure TForm1.Bt0Click(Sender: TObject);
begin
  IF neu Then
     BEGIN
       BtClearClick(Sender);
       neu := False
     END;
  EdDisplay.Text :=EdDisplay.Text+'0'
end;

procedure TForm1.BtSClick(Sender: TObject);
begin
  rz := '+';
  op1 := StrToFloat(EdDisplay.Text);
  BtClearClick(Sender)
end;

procedure TForm1.BtDClick(Sender: TObject);
begin
  rz := '-';
  op1 := StrToFloat(EdDisplay.Text);
  BtClearClick(Sender)
end;

procedure TForm1.BtPClick(Sender: TObject);
begin
  rz := '*';
  op1 := StrToFloat(EdDisplay.Text);
  BtClearClick(Sender)
end;

procedure TForm1.BtQClick(Sender: TObject);
begin
  rz := ':';
  op1 := StrToFloat(EdDisplay.Text);
  BtClearClick(Sender)
end;

procedure TForm1.BtGlClick(Sender: TObject);
begin
  op2 := StrToFloat(EdDisplay.Text);
  CASE rz OF
   '+': erg := op1 + op2;
   '-': erg := op1 - op2;
   '*': erg := op1 * op2;
   ':': IF op2 = 0.0
           THEN  EdDisplay.Text := 'ERROR'
           ELSE  erg := op1 / op2;
  END;
  IF  EdDisplay.Text <> 'ERROR'
     THEN  EdDisplay.Text := FloatToStr(erg);
  neu := True;
end;

procedure TForm1.BtVzClick(Sender: TObject);
begin
   IF neu Then
     BEGIN
       BtClearClick(Sender);
       neu := False
     END;
   EdDisplay.Text := FloatToStr(-StrToFloat(EdDisplay.Text))
end;

procedure TForm1.BtClearClick(Sender: TObject);
begin
   EdDisplay.Text :='';
   neu := True
end;

procedure TForm1.BtOffClick(Sender: TObject);
begin
  close
end;

procedure TForm1.BtKClick(Sender: TObject);
begin
  IF neu Then
     BEGIN
       BtClearClick(Sender);
       neu := False
     END;
  EdDisplay.Text :=EdDisplay.Text+','
end;

procedure TForm1.BtRootClick(Sender: TObject);
begin
   IF StrToFloat(EdDisplay.Text) < 0.0
           THEN  EdDisplay.Text := 'ERROR'
           ELSE  EdDisplay.Text :=
                FloatToStr(Sqrt(StrToFloat(EdDisplay.Text)));
   neu := True;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  neu := True
end;

procedure TForm1.BtFakClick(Sender: TObject);
VAR f,i,n:LongInt;
begin
   n := StrToInt(EdDisplay.Text);
   f := 1;
   FOR i := 1 TO n DO f := f * i;
   EdDisplay.Text := IntToStr(f);
   Neu := True
end;

end.
