program Billard7;

uses
  mSum,
  mTSpielfeld in 'mTSpielfeld.pas',
  mTKugel in 'mTKugel.pas';

var
  derBildschirm : Bildschirm;
  dieMaus       : Maus;
  ersteKugel    : TKugel;
  zweiteKugel    : TKugel;
  dritteKugel    : TKugel;
  dasSpielfeld  : TSpielfeld;

begin
  // Initialisierung
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  dasSpielfeld  := TSpielfeld.init(10,10,500,210);
  ersteKugel    := TKugel.init(50,50,10);
  zweiteKugel    := TKugel.init(250,75,125);
  dritteKugel    := TKugel.init(350,100,60);
  ersteKugel.merkeSpielfeld(dasSpielfeld);
  zweiteKugel.merkeSpielfeld(dasSpielfeld);
  dritteKugel.merkeSpielfeld(dasSpielfeld);

  // Aktionsteil
  dasSpielfeld.zeichneDich;
  repeat
    ersteKugel.bewege;
    zweiteKugel.bewege;
    dritteKugel.bewege;
  until dieMaus.istGedrueckt;
  

  // Aufrumen
  ersteKugel.gibFrei;
  zweiteKugel.gibFrei;
  dritteKugel.gibFrei;
  dieMaus.gibFrei;
  dasSpielfeld.gibFrei;
  derBildschirm.gibFrei
end.
