UNIT mTAnwendung;

interface

uses       mSum, mTWaggon, mTGueterwagen, mTPersonenwagen, mTLokomotive, mTZug,
         mTRechteckKnopf;
// Uses-Klausel ggf. anpassen

type
   TAnwendung = CLASS

     // Attribute
     protected
         derBildschirm : Bildschirm;
         dieMaus : Maus;
         dieTastatur : Tastatur;

     //Objektbeziehungen:
        // hatTastatur : Tastatur;
        // hatBildschirm : Bildschirm;
        // hatMaus : Maus;

     // Methoden
     public
        constructor init; virtual;
        procedure run; virtual; abstract;
        destructor gibfrei; virtual;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm     := Bildschirm.init;
  dieMaus           := Maus.init;
  dieTastatur       := Tastatur.init; 
end;

//-------- gibfrei (public) --------------------------------------------
destructor TAnwendung.gibfrei;
begin
  dieTastatur.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei
end;  

end.
