unit uTaschenrechner;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, mKnopf, mTextfeld, mSuM, mTextwerkzeug;

type
  TForm1 = class(TForm)
    EinAusgabe: TTextfeld;
    Knopf1: TKnopf;
    Knopf2: TKnopf;
    Knopf3: TKnopf;
    Knopf4: TKnopf;
    Knopf5: TKnopf;
    Knopf6: TKnopf;
    Knopf7: TKnopf;
    Knopf8: TKnopf;
    Knopf9: TKnopf;
    Knopf10: TKnopf;
    Plus: TKnopf;
    Minus: TKnopf;
    Mal: TKnopf;
    Geteilt: TKnopf;
    Gleich: TKnopf;
    Loesche: TKnopf;
    Punkt: TKnopf;
    Vorzeichen: TKnopf;
    procedure Knopf1Geklickt(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure PlusGeklickt(Sender: TObject);
    procedure GleichGeklickt(Sender: TObject);
    procedure LoescheGeklickt(Sender: TObject);
    procedure VorzeichenGeklickt(Sender: TObject);
  private
    { Private-Deklarationen }
    TW : Textwerkzeug;

  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
var ersteZahl, zweiteZahl, ergebnis : Zahl; operator : char;

procedure TForm1.Knopf1Geklickt(Sender: TObject);
 var alterInhalt, neuerInhalt : Zeichenkette;
begin
   alterInhalt := EinAusgabe.inhaltAlsText;
   neuerInhalt := TW.verkettung(alterInhalt,TKnopf(sender)._inhalt);
   // neuerInhalt := alterInhalt + TKnopf(sender)._inhalt;
   EinAusgabe.setzeInhalt(neuerInhalt);
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  TW := Textwerkzeug.init;
end;

procedure TForm1.PlusGeklickt(Sender: TObject);
begin
   ersteZahl := EinAusgabe.inhaltAlsZahl;
   operator := TKnopf(sender)._inhalt[1];
   EinAusgabe.setzeInhalt('');
end;

procedure TForm1.GleichGeklickt(Sender: TObject);
begin
   zweiteZahl := EinAusgabe.inhaltAlsZahl;
   case operator of
    '+' : ergebnis := ersteZahl + zweiteZahl;
    '-' : ergebnis := ersteZahl - zweiteZahl;
    '*' : ergebnis := ersteZahl * zweiteZahl;
    ':' : ergebnis := ersteZahl / zweiteZahl;
   end;
   EinAusgabe.setzeInhalt(ergebnis);
end;

procedure TForm1.LoescheGeklickt(Sender: TObject);
begin
  EinAusgabe.setzeInhalt('');
end;

procedure TForm1.VorzeichenGeklickt(Sender: TObject);
var alterInhalt, neuerInhalt : Zeichenkette;
begin
   alterInhalt := EinAusgabe.inhaltAlsText;
   If alterInhalt[1] <> '-' then
     neuerInhalt := TW.verkettung('-',alterInhalt)
   else
       neuerInhalt := TW.textOhne(alterInhalt,1,1);
   EinAusgabe.setzeInhalt(neuerInhalt);
end;

end.
